unit CommProcessDemoMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CommProcess, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    Memo1: TMemo;
    Memo2: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button3: TButton;
    CommProcess1: TCommProcess;
    OpenDialog1: TOpenDialog;
    Button4: TButton;
    Edit3: TEdit;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CommProcess1Error(const Director: TCommProcess;
      const ProcessError: TProcessError);
    procedure CommProcess1Execute(const Director: TCommProcess);
    procedure CommProcess1Terminate(const Director: TCommProcess);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CommProcess1Exit(const Director: TCommProcess;
      const ExitCode: Integer);
    procedure CommProcess1GetErrOut(const ProcessID: Cardinal;
      const Text: String);
    procedure CommProcess1GetStdOut(const ProcessID: Cardinal;
      const Text: String);
    procedure ComboBox1Select(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
	CommProcess1.SetOutputStrings( Memo1.Lines, Memo2.Lines );
	Edit1.Text := CommProcess1.CommandLine;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	if( CommProcess1.IsRunning ) then
	begin
		CommProcess1.KillProcess;
	end else
	begin
		CommProcess1.CommandLine := Edit1.Text;
		CommProcess1.Option := Edit3.Text;
		ComboBox1.Enabled := False;
		CommProcess1.StartProcess;
		Button1.Caption := 'f';
	end;
end;

procedure TForm1.CommProcess1Error(const Director: TCommProcess;
  const ProcessError: TProcessError);
begin
	Memo2.Lines.Append( 'Error' );
end;

procedure TForm1.CommProcess1Execute(const Director: TCommProcess);
begin
	Memo1.Lines.Append( 'Execute' );
	Button1.Caption := 'f';
	ComboBox1.Enabled := False;
end;

procedure TForm1.CommProcess1Terminate(const Director: TCommProcess);
begin
	Memo1.Lines.Append( 'Terminated' );
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
	if( OpenDialog1.Execute ) then
	begin
		Edit1.Text := OpenDialog1.FileName;
		CommProcess1.CommandLine := OpenDialog1.FileName;
	end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
	CommProcess1.SendCommand( Edit2.Text );
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
	Close;
end;

procedure TForm1.CommProcess1Exit(const Director: TCommProcess;
  const ExitCode: Integer);
begin
	Memo1.Lines.Append( 'Exit[ExitCode:'+IntToStr(ExitCode)+']' );
	Button1.Caption := 's';
	ComboBox1.Enabled := True;
end;

procedure TForm1.CommProcess1GetErrOut(const ProcessID: Cardinal;
  const Text: String);
begin
	Memo2.Lines.Append( 'GetText[PrcessID:'+ IntToStr( ProcessID ) +']: '+Text );
end;

procedure TForm1.CommProcess1GetStdOut(const ProcessID: Cardinal;
  const Text: String);
begin
	Memo1.Lines.Append( 'GetText[PrcessID:'+ IntToStr( ProcessID ) +']: '+Text );
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
begin
	case ComboBox1.ItemIndex of
	0:	CommProcess1.LineFeedChar := LFCR;
	1:	CommProcess1.LineFeedChar := LF;
	2: 	CommProcess1.LineFeedChar := CR;
	3:	CommProcess1.LineFeedChar := CRLF;
	4: 	CommProcess1.LineFeedChar := LFLF;
	else
		CommProcess1.LineFeedChar := CRLF;
	end;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
	if( Key = #13 ) then	//EnterL[Ȃc
	begin
		CommProcess1.SendCommand( Edit2.Text );
		Edit2.Text := '';	//Ƃ肠NA
		Key := #0;		//̂}~
	end;
end;

end.
